﻿using System.Text.Json;
using PCC.Common.AssemblyInject.Interfaces;

namespace PCC.Configuration;

public abstract class PccDevConfigManagerBase : IAssemblyInjectSyncInitStarStop<PccDevConfigManagerBase>
{
    private const string FileName = "PCC-DEV-Config.json";
    public PccDevConfigFile Instance { get; private set; } = new();

    public void Load()
    {
        if (File.Exists(FileName))
            Instance = JsonSerializer.Deserialize<PccDevConfigFile>(File.ReadAllText(FileName))!;
    }

    public void Save() => File.WriteAllText(FileName, JsonSerializer.Serialize(Instance));

    public void Init()
    {
        Load();
    }

    public void Start()
    {
    }

    public void Stop()
    {
        Save();
    }
}