﻿using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace PCC.DbEntity;

[Table("ChatRecords")]
[Microsoft.EntityFrameworkCore.Index(nameof(TxPeerId), nameof(SenderTimestamp))]
[Microsoft.EntityFrameworkCore.Index(nameof(RxPeerId), nameof(SenderTimestamp))]
public class ChatRecord
{
    [Key]
    [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
    public int Id { get; set; }

    [Required]
    [Length(128, 128)]
    [Column(TypeName = "CHAR(128)")]
    public string? TxPeerId { get; set; }

    [Required]
    [Length(128, 128)]
    [Column(TypeName = "CHAR(128)")]
    public string? RxPeerId { get; set; }

    [Column(TypeName = "BIGINT")]
    public DateTimeOffset SenderTimestamp { get; set; }

    [Required]
    [Column(TypeName = "TEXT")]
    public string? Content { get; set; }

    [Column(TypeName = "BIGINT")]
    public DateTimeOffset? AckTimestamp { get; set; }
}
